//---------------------------------------------------------------------------
//
//  Module: portio.h
//
//  Purpose:
//     Defines the inline inp*() and outp*() operators.   
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              4/10/93   BryanW      Borrowed from Watcom's CONIO.H.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifdef __WATCOMC__

#ifdef	__INLINE_FUNCTIONS__
 extern unsigned inp(unsigned __port);
 extern unsigned inpw(unsigned __port);
 extern unsigned outp(unsigned __port, unsigned __value);
 extern unsigned outpw(unsigned __port,unsigned __value);

 extern unsigned _inline_inp( unsigned ) ;
 extern unsigned _inline_inpw( unsigned ) ;
 extern unsigned _inline_outp( unsigned, unsigned ) ;
 extern unsigned _inline_outpw( unsigned, unsigned ) ;

 #define inp(__x)	_inline_inp(__x)
 #define inpw(__x)	_inline_inpw(__x)
 #define outp(__x,__y)	_inline_outp(__x,__y)
 #define outpw(__x,__y) _inline_outpw(__x,__y)
#else
#error use -Oi to enable inline functions
#endif

#endif

//---------------------------------------------------------------------------
//  End of File: portio.h
//---------------------------------------------------------------------------

