        page    60, 132

;******************************************************************************
	title	VDDSVCA - assembly routines for VDDSVC.C
;******************************************************************************
;
;   (C) Copyright Woodruff Software Systems, 1993
;
;   Title:    VDDSVCA - assembly routines for VDDSVC.C
;
;   Module:   VDDSVCA.ASM
;
;   Version:  1.00
;
;   Date:     October 25, 1993
;
;   Author:   Bryan A. Woodruff
;
;******************************************************************************
;
;   Change log:
;
;   DATE      REVISION  DESCRIPTION                                 AUTHOR
;   --------  --------	------------------------------------------  -----------
;   10/25/93  1.00      Pulled from original DDK sources            BryanW
;
;******************************************************************************
;
;   Functional Description:
;
;      Ring 0 hack-o-matic interface - not converted to C to avoid
;      the messing around with the registers.
;
;******************************************************************************

        .386p

;==============================================================================
;                     I N C L U D E S   &   E Q U A T E S
;==============================================================================

.xlist
	INCLUDE VMM.INC
	INCLUDE DEBUG.INC
.list

;==============================================================================
;                       P A G E A B L E   C O D E
;==============================================================================

VXD_CODE_SEG

;----------------------------------------------------------------------------
;
;   VDD_Jump_To_Ring0
;
;   DESCRIPTION:
;      Call-Back entered as far call from VM's pmode code.
;
;   ENTRY:
;      regular client frame
;      EDX = ring 0 alias
;
;   EXIT:
;
;   USES:
;
;----------------------------------------------------------------------------

BeginProc VDD_Jump_To_Ring0

	VMMCall Simulate_Far_Ret
	pop	eax			; get our ret-to address
	push	cs			; convert to a far ret
	push	eax
	push	ebp			; save client ptr
	push	edx			; push ring 0 alias
	movzx	eax, [ebp.Client_IP]
	push	eax			; push dsp drvr's ip

	Client_Ptr_Flat eax, ss, bp	; eax = linear address of Client_SS:BP

	mov	es, [ebp.Client_ES]
	mov	ds, [ebp.Client_DS]
	mov	ecx, [ebp.Client_ECX]
	mov	esi, [ebp.Client_ESI]
	mov	edi, [ebp.Client_EDI]
	mov	ebp, eax		; ebp -> display driver's stack frame
	retf				; ret to dsp drvr just after call to
					;   switch to ring 0

EndProc VDD_Jump_To_Ring0

;----------------------------------------------------------------------------
;
;   VDD_Jump_To_Ring3
;
;   DESCRIPTION:
;      Special routine that is a non-flat ring 0 entry point for
;      the display driver to use to get back to ring 3.  The
;      non-flat ip of this routine is 0.
;
;   ENTRY:
;      Entered as FAR CALL from ring0 code in display driver
;
;   EXIT:
;
;   USES:
;
;----------------------------------------------------------------------------

BeginProc VDD_Jump_To_Ring3, no_log

	pop	eax			; pop ring0 cs:ip
	pop	ebp			; pop saved client ptr
	mov	[ebp.Client_IP], ax
	mov	[ebp.Client_ECX], ecx
	mov	[ebp.Client_ESI], esi
	mov	[ebp.Client_EDI], edi
	mov	ax, ss
	mov	ds, ax
	mov	es, ax
	retf				; ret to caller of VDD_Jump_To_Ring0

EndProc VDD_Jump_To_Ring3

VXD_CODE_ENDS

end

