//---------------------------------------------------------------------------
//
//  Module: vglobald.h
//
//  Purpose: Header file for vglobald.c
//
//  Development Team:
//     Bryan A. Woodruff
//
//  History:   Date       Author      Comment
//              3/ 9/93   BryanW      Wrote it.
//
//---------------------------------------------------------------------------
//
//               Copyright (c) 1993 Woodruff Software Systems.
//                          All Rights Reserved.
//
//---------------------------------------------------------------------------

// equates

#define VGLOBALD_Major_Ver   0x01
#define VGLOBALD_Minor_Ver   0x00
#define VGLOBALD_Device_ID   (Undefined_Device_ID)

// macros

#define UNUSED_PARAM( x ) x = x ;

// data structures

typedef struct tagVMCB
{
   PDWORD pPageTable ;

} VMCB, *PVMCB ;

// global data

extern UINT      guCBOffset ;
extern DWORD     ghOwnerVM ;
extern WORD      gwGlobalPage ;
extern PDWORD    gpPageDir ;
extern IPFPROC   pVGLOBALD_Invalid_PFault ;

// prototypes

BOOL CDECL VGLOBALD_Device_Init( DWORD, PSTR, PCRS_32 ) ;
BOOL CDECL VGLOBALD_VM_Init( DWORD ) ;
BOOL CDECL VGLOBALD_Create_VM( DWORD ) ;
BOOL CDECL VGLOBALD_Destroy_VM( DWORD ) ;
BOOL CDECL VGLOBALD_Invalid_PFault( DWORD, PIPFDATA ) ;

// from CR3.ASM

DWORD PASCAL GetCR3( VOID ) ;

//---------------------------------------------------------------------------
//  End of File: vglobald.h
//---------------------------------------------------------------------------
