.386

include	..\win_ipc.inc

DGROUP	group _DATA


CallVxd	MACRO	msg
local	a
	mov	eax, msg
	cmp	[VxdCallAddr], 0
	je	short a
	call	dword ptr [VxdCallAddr]
a:
ENDM

_DATA	segment	dword use16 public 'DATA'
assume	ds:DGROUP

VxdCallAddr	dd	?
VmHdl		dd	?

_DATA	ends


_TEXT	segment	dword use16 public 'CODE'
	assume	cs:_TEXT

if WIN
	public	_IpcInit
else
	public	_IpcRegister, _IpcUnregister, _IpcLaunch
	public	_IpcMsgPeek, _IpcMsgRead
	public	_IpcPrintOpen, _IpcPrintWrite, _IpcPrintClose
endif
	public	_IpcQueryVm, _IpcMsgPost, _IpcMemCopy, _IpcSetTitle
	public	_IpcMemLdt, _IpcMemFreeLdt, _IpcMemGdt, _IpcMemFreeGdt


if WIN

; IpcInit (void);
_IpcInit	proc near
assume	cs:_TEXT, ds:DGROUP

	; Get the call address
	push	es
	xor	di, di
	mov	es, di
	mov	ax, 1684h
	mov	bx, WIN_IPC_ID
	int	2Fh
	mov	word ptr [VxdCallAddr], di
	mov	word ptr [VxdCallAddr+2], es
	mov	ax, es				; for test below
	or	ax, di
	pop	es

	xor	edx, edx			; if No call address
	or	ax, ax
	jz	short ir30

	xor	ax, ax
	ret

ir30:	mov	ax, -1
	ret

_IpcInit	endp


else


; long IpcRegister (char far *pName);
_IpcRegister	proc near
assume	cs:_TEXT, ds:DGROUP

	; Is Windows386 3.0+ running?
	mov	ax, 1600h
	int	2Fh
	test	al, 7Fh
	jnz	short ir20			; We have Windows 386

ir10:	xor	eax, eax			; No Windows 3.0/386
	jmp	short ir30

ir20:	cmp	al, 1
	je	ir10				; Win386 2.0
	cmp	al, -1
	je	ir10				; Win386 2.0

	; Get the call address
	push	es
	xor	di, di
	mov	es, di
	mov	ax, 1684h
	mov	bx, WIN_IPC_ID
	int	2Fh
	mov	word ptr [VxdCallAddr], di
	mov	word ptr [VxdCallAddr+2], es
	pop	es

	xor	eax, eax			; For return on error
	cmp	[VxdCallAddr], eax
	je	short ir30

	; Give Vxd our ID
	; ENTRY:	AX = MSG_REGISTER
	;		EDX = pName
	; EXIT:		EAX = hVm
	push	bp
	mov	bp, sp
	mov	edx, [bp+4]
	pop	bp

	CallVxd	MSG_REGISTER

	mov	[VmHdl], eax

ir30:	mov	edx, eax			; rtn VM
	shr	edx, 16
	ret

_IpcRegister	endp


; void IpcUnregister (void);
_IpcUnregister	proc near
assume	cs:_TEXT, ds:DGROUP

	CallVxd	MSG_UNREGISTER

	ret

_IpcUnregister	endp


endif


; long IpcQueryVm (char far *pName);
_IpcQueryVm	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_QUERY_VM
	;		EDX = pName
	; EXIT:		EAX = hVm
	push	bp
	mov	bp, sp
	mov	edx, [bp+4]
	pop	bp

	CallVxd	MSG_QUERY_VM

	mov	edx, eax			; rtn VM
	shr	edx, 16
	ret

_IpcQueryVm	endp


ife WIN


; unsigned int IpcLaunch (char far *pCmd,unsigned uShow);
_IpcLaunch	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_LAUNCH
	;		CX = uShow
	;		EDX = pCmd
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	edx, [bp + 4]
	movzx	ecx,  word ptr [bp + 8]
	pop	bp

	CallVxd	MSG_LAUNCH

	ret

_IpcLaunch	endp


endif


; unsigned int IpcMsgPost (long hVm,HWND hWnd,WORD wMsg,WORD wParam,LONG lParam)
_IpcMsgPost	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_POST
	;		EBX = hVm
	;		ECH = hWnd
	;		ECL = wMsg
	;		DI = wParam
	;		EDX = lParam
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	ebx, [bp + 4]
	mov	ecx, [bp + 8]
	mov	 di, [bp + 12]
	mov	edx, [bp + 14]
	pop	bp

	CallVxd	MSG_POST

	ret

_IpcMsgPost	endp


ife WIN


; unsigned int IpcMsgPeek (MSG far *pMsg);
_IpcMsgPeek	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_PEEK
	;		EDX = pMsg
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	edx, [bp+4]
	pop	bp

	CallVxd	MSG_PEEK

	ret

_IpcMsgPeek	endp


; BOOL IpcMsgRead (MSG far *pMsg);
_IpcMsgRead	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_READ
	;		EDX = pMsg
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	edx, [bp+4]
	pop	bp

	CallVxd	MSG_READ

	ret

_IpcMsgRead	endp


; int IpcPrintOpen (char far *pName);
_IpcPrintOpen	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_COPY
	;		EDX = pName
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	edx, [bp+4]
	pop	bp

	CallVxd	MSG_PRN_OPEN

	ret

_IpcPrintOpen	endp


; unsigned int IpcPrintWrite (void far *pBuf,unsigned int uNum)
_IpcPrintWrite	proc near
assume	cs:_TEXT, ds:DGROUP

	Save	<bp,ds>

	mov	bp, sp
	lds	si, [bp + 6]
	mov	cx, [bp + 10]
	jcxz	ipw20

ipw10:	lodsb
	xor	ah, ah
	xor	dx, dx
	int	17h
	loop	ipw10

ipw20:	Restore	<ds,bp>
	ret

_IpcPrintWrite	endp


; void IpcPrintClose ();
_IpcPrintClose	proc near
assume	cs:_TEXT, ds:DGROUP

	CallVxd	MSG_PRN_CLOSE

	ret

_IpcPrintClose	endp


endif


; int IpcMemCopy (long lSrcVm,void far *pSrc,long lDestVm,void far *pDest,unsigned uNum)
_IpcMemCopy	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_COPY
	;		EBX = SrcVm
	;		ECX = uNum
	;		EDX = DestVm
	;		EDI = pDest
	;		ESI = pSrc
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	ebx, [bp + 4]
	mov	esi, [bp + 8]
	mov	edx, [bp + 12]
	mov	edi, [bp + 16]
	movzx	ecx, [bp + 20]
	pop	bp

	CallVxd	MSG_MEM_COPY

	ret

_IpcMemCopy	endp


; unsigned int IpcMemLdt (long VmLdt,long VmMem,void far *pBuf,unsigned long ulLimit);
_IpcMemLdt	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_LDT
	;		EBX = VmLdt
	;		EDX = VmMem
	;		EDI = pBuf
	;		ECX = ulLimit
	; EXIT:		AX = selector
	push	bp
	mov	bp, sp
	mov	ebx, [bp + 4]
	mov	edx, [bp + 8]
	mov	edi, [bp + 12]
	mov	ecx, [bp + 16]
	pop	bp

	CallVxd	MSG_MEM_LDT

	ret

_IpcMemLdt	endp


; unsigned int IpcMemFreeLdt (long lVmMem,unsigned Sel);
_IpcMemFreeLdt	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_FREE_LDT
	;		EBX = VmMem
	;		EDX = selector
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	ebx, [bp + 4]
	movzx	edx, word ptr [bp + 8]
	pop	bp

	CallVxd	MSG_MEM_FREE_LDT

	ret

_IpcMemFreeLdt	endp


; unsigned int IpcMemGdt (long VmMem,void far *pBuf,unsigned long ulLimit);
_IpcMemGdt	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_GDT
	;		EDX = VmMem
	;		EDI = pBuf
	;		ECX = ulLimit
	; EXIT:		AX = selector
	push	bp
	mov	bp, sp
	mov	edx, [bp + 4]
	mov	edi, [bp + 8]
	mov	ecx, [bp + 12]
	pop	bp

	CallVxd	MSG_MEM_GDT

	ret

_IpcMemGdt	endp


; unsigned int IpcMemFreeGdt (unsigned Sel);
_IpcMemFreeGdt	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = MSG_MEM_FREE_GDT
	;		EDX = selector
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	movzx	edx, word ptr [bp + 4]
	pop	bp

	CallVxd	MSG_MEM_FREE_GDT

	ret

_IpcMemFreeGdt	endp


; unsigned int IpcSetTitle (char far *pName);
_IpcSetTitle	proc near
assume	cs:_TEXT, ds:DGROUP

	; ENTRY:	AX = _MSG_SET_TITLE
	;		EDX = pName
	; EXIT:		AX = uErr
	push	bp
	mov	bp, sp
	mov	edx, [bp + 4]
	pop	bp

	CallVxd	MSG_SET_TITLE

	ret

_IpcSetTitle	endp


_TEXT	ends

	end
